#include <stdio.h>
#include <time.h>
#include "../src/smtp.h"
#include "bm.h"
/* send a message */
dosmtpsend(mfp,recip)
FILE *mfp;
char *recip;
{
	char	smtp_to[LINELEN], 
		smtp_subject[LINELEN], 
		tohost[LINELEN],
		thishost[LINELEN],
		tfilename[LINELEN], 
		wfilename[LINELEN],
		sfilename[LINELEN],
		lfilename[LINELEN],
		tstring[LINELEN],		/* temp for integer conv */
		ptimestr[40];
	char	*tch,*rindex();
	int	sequence;
	FILE	*tfile, *wfile, *sfile, *lfile;
	char *cp;

	/* open the sequence file */
	strcpy(sfilename,MAILQDIR);
	strcat(sfilename,"sequence.seq");
	sfile = fopen(sfilename,"r");

	/* if sequence file exists, get the value, otherwise fake it */
	if (sfile == NULL) 
		strcpy(tstring,"0");
	else {
		fgets(tstring,LINELEN,sfile);
		fclose(sfile);
	}
	sequence = atoi(tstring);

	/* increment sequence number, and write to sequence file */
	sfile = fopen(sfilename,"w");
	fprintf(sfile,"%d",++sequence);

	/* close the sequence file */
	fclose(sfile);

	ptime(&ptimestr);

	if(recip == NULL){
		/* prompt and get To: */
		printf("\nTo:      ");
		gets(smtp_to);
	} else
		strcpy(smtp_to,recip);
	
	/* prompt and get Subject: */
	printf("Subject: ");
	gets(smtp_subject);

	/* Prompt and get CC: */
#ifdef	notdef
	printf("CC:      ");
	gets(smtp_cc);
#endif

	/* create lock in mqueue directory */
	sprintf(lfilename,"%s%d%s",MAILQDIR,sequence,".lck");
	if((lfile = fopen(lfilename,"x")) == NULL) {
		printf(" Cannot create lock file\r\n");
		return;
	}
	fclose(lfile);

	/* open textfile in mqueue directory */
	sprintf(tfilename,"%s%d%s",MAILQDIR,sequence,".txt");
	tfile = fopen(tfilename,"w+");		/* open textfile for write */

	/* write (almost) RFC822-compatible headers using above information */
	fprintf(tfile,"Date: %s",ptimestr);
	fprintf(tfile,"From: %s@%s\n",username,hostname);
	fprintf(tfile,"To: %s\n",smtp_to);
#ifdef	notdef
	fprintf(tfile,"cc: %s\n",smtp_cc);
#endif
	fprintf(tfile,"Subject: %s\n",smtp_subject);
	fprintf(tfile,"Message-Id: <%u@%s>\n",sequence,hostname);
	fprintf(tfile,"\n");	            /* add empty line as separator */

	if(mfp != NULL){
		while(!feof(mfp)){
			fgets(tstring,LINELEN,mfp);
			rip(tstring);
			fprintf(tfile,"%s\n",tstring);
		}
		fclose(tfile);
	} else {
		/* sending a message not from a file */
                /* copy text from console to the file */
printf("\nType message text.  Enter a '.' or ctrl/D in column one to end.");
printf("\nCommands: ~p - redisplay msg, ~e - invoke editor\n\n");
		for(;;){
			gets(tstring);		  /* read line from console */
			if(strcmp(tstring,".") == 0 || tstring[0] == '\004')
				break;	
			else if(strcmp(tstring,"~p") == 0){
				/* Print the message so far */
				fseek(tfile,0L,0);
				while(!feof(tfile)){
					fgets(tstring,sizeof(tstring),tfile);
					fputs(tstring,stdout);
				}
				printf("(continue)\r\n");
			}else if(strcmp(tstring,"~e") == 0){
				/* Drop into editor */
				fclose(tfile);
				backslash(tfilename);   /* convert '/' to '\\' */
				sprintf(tstring,"%s %s",editor,tfilename);
				system(tstring);       /* call editor to enter message text */
				tfile = fopen(tfilename,"a+");
				printf("(continue)\r\n");
			} else
				fprintf(tfile,"%s\n",tstring);
		}
		printf("EOF\r\n");
		fclose(tfile);
	}
	if((cp = rindex(smtp_to,'@')) == NULL){
		/* local mail */
		strcpy(tohost,hostname);
	} else {
		cp++;
		strcpy(tohost,cp);
	}		
	/* open a workfile in the mqueue directory */
	sprintf(wfilename,"%s%d%s",MAILQDIR,sequence,".wrk");
	wfile = fopen(wfilename,"w");		/* open textfile for write */
	fprintf(wfile,"%s\n%s@%s\n%s\n",tohost,username,hostname,smtp_to);
	fclose(wfile);

	/* remove lock in mqueue directory */
	unlink(lfilename);	/* erase the lock file */

	printf("messageid=%u  Done.\n",sequence);
}

/* Return Date/Time in Arpanet format in passed string */
ptime(str)
char *str;
{
	/* Print out the time and date field as
	 *		"DAY day MONTH year hh:mm:ss ZONE"
	 */
	long t;
	struct tm *ltm;
	static char *days[7] = {
    "Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday" };

	static char *months[12] = {
		"Jan","Feb","Mar","Apr","May","Jun",
		"Jul","Aug","Sep","Oct","Nov","Dec" };

	/* Read the system time */
	time(&t);
	ltm = gmtime(&t);

	/* most of the inportent things are decoded , encript into string */
	sprintf(str,"%s, %02d %s 19%02d %02d:%02d:%02d %s\n"
		,days[ltm->tm_wday],ltm->tm_mday,months[ltm->tm_mon],
		 ltm->tm_year,ltm->tm_hour,ltm->tm_min,ltm->tm_sec,
		 timezone);
}

/* replace all '/' with '\' in the passed string. */
backslash(s)
char *s;
{
  while (*s != '\0') {
    if (*s == '/')       /* replace slash with backslash */
      *s = '\\';   
    s++;
  }
}
